package StackArray;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an E[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class GenericStack<E> {

    private E[] elements;

    public GenericStack() {
        //elements = Arrays.copyOf(this.elements, this.elements.length + 1);
        //elements = (E[])Array.newInstance(E, 0);
        //elements = (E[]) Array.newInstance(this.elements.getClass().getComponentType(), 1);
        elements = (E[]) new Object[0];
    }

    public boolean isEmpty() {
        return elements.length == 0 ? true : false;
    }

    public void push(E foobar) {
        elements = Arrays.copyOf(this.elements, this.elements.length + 1);
        // shift right
        for( int index =elements.length-2; index >= 0 ; index-- ) {
            elements[index+1] = elements [index];
        }
        elements[0] = foobar;
    }

    public E pop() {
        if(this.elements.length == 0){
            throw new IndexOutOfBoundsException();
        }
        E[] newElements = Arrays.copyOf(this.elements, this.elements.length - 1);

        E poped = this.elements[0];

        int newArrayCounter = 0;

        for(int i = 1; i < this.elements.length; i++){
            newElements[newArrayCounter] = this.elements[i];
            newArrayCounter++;
        }

        this.elements = newElements;

        return poped;



    }
}
