package StackArray;

import com.sun.tools.javah.Gen;

import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an Object[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class ObjectStack<E> {
    private Object[] elements;

    private GenericStack<Object> genericStack;

    public ObjectStack() {
        genericStack =  new GenericStack<Object>();

    }

    public boolean isEmpty() {
        return genericStack.isEmpty();
    }

    public void push(E foobar) {
        genericStack.push(foobar);
    }

    public Object pop() {
        return genericStack.pop();
    }
}