package StackArrayList;

import java.util.ArrayList;

/**
 * Implement Stack<E> by adding the push, pop, and isEmpty functions.  It must pass the prewritten unit tests.
 * If you pop on an empty stack, throw an IndexOutOfBoundsException.
 */
public class Stack<E> {
    private ArrayList<E> elements = new ArrayList<>();


    public Stack(){}

    public boolean isEmpty() {
        return elements.isEmpty();
    }

    public void push(E foobar) {
        this.elements.add(0, foobar);

    }

    public E pop() {
        return elements.remove(0);
    }
}
